/**
 * XValidator.java
 *
 * File generated from the XValidationReport1::XValidator uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import org.w3c.dom.Node;

/**
 * Description of the class XValidator.
 *
 */
@Entity
@Table(name="xval_cross_validator_reference", schema="public")
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CrossValidatorReference", propOrder = { "name", "version", "affinityDomain" })
@XmlRootElement(name = "CrossValidatorReference")
@SequenceGenerator(name="xval_cross_validator_reference_sequence", sequenceName="xval_cross_validator_reference_id_seq", allocationSize=1)
public class CrossValidatorReference implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;
	
	@XmlTransient
	@Id
	@GeneratedValue(generator="xval_cross_validator_reference_sequence", strategy=GenerationType.SEQUENCE)
	@Column(name="id", unique=true, nullable=false)
	private Integer id;

	@XmlAttribute(name = "name", required = true)
	private String name;
	@XmlAttribute(name = "version")
	private String version;
	@Column(name="affinity_domain")
	@XmlAttribute(name = "affinityDomain", required = true)
	private String affinityDomain;
	
	@XmlTransient
	@ManyToMany(mappedBy="validatorParents", targetEntity=GazelleCrossValidatorType.class)
	private List<GazelleCrossValidatorType> children;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	public CrossValidatorReference() {
		super();
	}
	
	public CrossValidatorReference(GazelleCrossValidatorType validator){
		this.name = validator.getName();
		this.affinityDomain = validator.getAffinityDomain();
		this.version = validator.getVersion();
	}

	public CrossValidatorReference(String name2, String version2, String affinityDomain2) {
		super();
		this.name = name2;
		this.version = version2;
		this.affinityDomain = affinityDomain2;
	}

	/**
	 * Return name.
	 * 
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Set a value to attribute name.
	 * 
	 * @param name
	 *            .
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Return version.
	 * 
	 * @return version
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * Set a value to attribute version.
	 * 
	 * @param version
	 *            .
	 */
	public void setVersion(String version) {
		this.version = version;
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "CrossValidatorReference", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public String getAffinityDomain() {
		return affinityDomain;
	}

	public void setAffinityDomain(String affinityDomain) {
		this.affinityDomain = affinityDomain;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

}